<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: plugins/devices/device.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: plugins/devices/device.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
*
* @requires medley
* @requires node-midi
* @requires serialport
* @requires net
* @requires request
* @requires dgram
* @requires json5
*
* @todo add stencils and stencils collection like in the old days. See editor.js
*
* @module device
*/

try {
  var osc = require('osc-min')
} catch (err) {
  var osc = null
  console.log("running without osc module")
}

try {
  var SerialPort = require('serialport')
  var Readline = require('@serialport/parser-readline')
} catch (err) {
  var SerialPort = null
  console.log("running without serial module")
}

const medley = require('../../medley.js')
const dgram = require('dgram')
const net = require('net')
const request = require('request')

const JSON5 = require('json5')

var midi = null
var virtual_midi_port = ''

/**
* midi makes trouble on some machines so it needs to be activated manually
*
*/
function activateMidi() {
  try {
    midi = require('midi')
    /** global var that holds name of virtual midi port. Keeps it to one virtual midi port per game */
    virtual_midi_port = ''
    log.info("devices", "Midi is active.")
  } catch (err) {
    midi = null
    log.info("devices", "Midi is inactive.")
  }
}

function deactivateMidi() {
  midi = null
  log.info("devices", "Midi is inactive.")
}

/**
* define a name for the virtual midi in and out ports
*
* @param {string} vmp - name for virtual midi port
*/
function setVirtualMidiPort(vmp) {
  virtual_midi_port = vmp
}

/**
* enlist all available port names. (Serial, Midi)
* prepend a possible virtual midi port based on game name
*
* @param {string} game - name of game that is requesting ports
*
* @returns {Promise} object with array for each serial and midi portnames. Arrays are empty [] if no valid pors are found
*/
function getPorts() {
  return new Promise(function (resolve, reject) {
    var ports = {}
    if (midi) {
      input = new midi.input()
      ports["midi_input"] = [virtual_midi_port]

      for (let i = 0; i &lt; input.getPortCount(); i++) {
        if (input.getPortName(i) != virtual_midi_port) {
          ports.midi_input.push(input.getPortName(i))
        }
      }

      output = new midi.output()
      ports["midi_output"] = [virtual_midi_port]

      for (let i = 0; i &lt; output.getPortCount(); i++) {
        if (output.getPortName(i) != virtual_midi_port) {
          ports.midi_output.push(output.getPortName(i))
        }
      }
    }

    if (SerialPort) {
      ports["serial"] = []

      SerialPort.list(function (err, serial_ports) {
        for (port of serial_ports) {
          if (port.serialNumber) {
            ports.serial.push(port.comName)
          }
        }
        resolve(ports)
      })
    } else {
      resolve(ports)
    }
  })
}

/**
* create and return device based on interface as specified in device settings
* defaults to device collection for data storage
*
* @param {Object} data - data set the device will be based on
* @param {Object} db - interface to Database
* @param {Object} app - express app to allow http requests and routing for webdevice
*
* @returns {Device} instance of one of the device classes
*/
function getDevice(data, db, app) {
  if (!data.hasOwnProperty("collection")) {
    data["collection"] = "device"
  }
  switch (data.settings.interface.toUpperCase()) {
    case "UDP":
      return new UDPdevice(data, db)
      break

    case "OSC":
      return new OSCdevice(data, db)
      break

    case "TCP":
      return new TCPdevice(data, db)
      break

    case "HTTP":
      return new Webdevice(data, db, app)
      break

    case "SERIAL":
      return new Serialdevice(data, db)
      break

    case "MIDI":
      return new Mididevice(data, db)
      break

    default:
      log.error("getDevice", "no such interface " + data.settings.interface)
      return undefined
      break
  }
}

/**
* Has Access to write incomming messages to DB.
* Devices should define their own [send]{@link Device#send} function and redirect incomming
* messages as JSON or JSON fromatted string to the [update]{@link Device#update} function.
*
* @param {Object} config - contains all device specifications
* @param {string} config.name - name identifier for Device
* @param {string} config.interface - connection protocoll that is used for communication
* @param {Object} config.settings - specification of interface parameters
* @param {Object} config.properties - properties the device can send and/or receive
* @param {Collection} db - instance of Database connection
*/
class Device {
  constructor(config, db) {
    Object.assign(this, config)
    this.db = db

    log.debug(0, "Device created: " + config.name)
  }

  /**
  * validate incomming message and update status in DB
  * 
	* objects are appended to the status variable in dot notation ('key1.key2') so they
	* don't overwrite existing variables
  *
  * single values (string, number) will overwrite all existing values!
	*
  * if message has _player property, status is saved to specified player
  *
  * if default value is specified, start a session of specified level if:
  * incoming message contains reference value.
  * assigns player as found by reference value.
  * creates player if none is found.
  *
  * @todo - fire event that can be catched instead of installing a listener on DB
  *
	*				- filter more keywords:
	*				"_get": allow to retrieve status data from device
	*       "_set": allow to set status/player properties directly (on first level)
  *
  * @param {Object|string} message - json formatted message
  */
  update(message) {
    if (!message) { return }
    if (typeof message === 'string') {
      try {
        message = JSON5.parse(message)
      } catch (err) {
        log.warn(this.name, 'error when parsing string to json. Will save data as single string, overwriting existing data.')
        //log.debug(this.name, err)
      }
    }

    if (this.hasOwnProperty("default")) {
      if (this.default.hasOwnProperty("reference") &amp;&amp; this.default.hasOwnProperty("level")) {
        for (let key in message) {
          if (this.default.reference == key) {
            let player_query = {}
            player_query[key] = message[key]
            
            this.db.player.find(player_query)
            .then(result => {
              if(result.length > 0) {
                this.startDefaultLevel(player_query, this.default.level)
              } else {
                log.warn(this.name, "try starting default session but no matching player found.")
              }
            })
            .catch(error => {
              log.error(this.name, error)
            })

            continue
          }
        }
      } else {
        log.warn(this.name, "try starting default level but reference or level is missing.")
      }
    }

    if (message.hasOwnProperty('_player')) {
      var collection = "player"
      var property = this.name
      if (typeof message._player === 'string') {
        var target = { "name": message._player }
      } else {
        var target = message._player
      }
      delete message._player
    } else {
      var collection = this.collection
      var property = "status"
      var target = { '_id': this._id }
    }

    let data = {}

    if (typeof message === 'number' || typeof message === 'string') {
      data[property] = message
      this.single_value = true
    } else if (this.single_value) {
      data[property] = message
      this.single_value = false
    } else {
      let path = ''
      for (let key in message) {
        let path = property + '.' + key
        data[path] = message[key]
      }
    }

    /*
    log.debug(this.name, target)
    log.debug(this.name, "document in collection " + collection + " set: ")
    log.debug(this.name, data)
    */

    this.db[collection].set(target, data)

  }

  /**
  * change connection properties and restart server/connection if needed
  * all device types that can change connection properties (meaning all, I guess) have to have this
  * @abstract
  * @param {Object} settings - (Updated) device settings
  */
  reconnect(settings) {
    log.error(this.name, 'No reconnect function defined for "' + this.constructor.name + '"! Tried to update: ')
    log.error(this.name, settings)
  }

  /**
  * send data to device.
  *
  * @abstract
  * @param {Object} data - data to send.
  */
  send(data) {
    log.error(this.name, 'No send function defined for "' + this.constructor.name + '"! Tried to send: ')
    log.error(this.name, data)
  }
  
  /**
  * store current device settings to device document on database
  */
  storeSettings() {
    this.db.device.set({_id:this._id}, {settings:this.settings})
  }
  
  /**
  * @todo add reconnect command
  */
  command(input) {
    switch (input[0]) {
      case "send":
        try {
          this.send(JSON5.parse(input[1]))
        } catch (err) {
          log.warn(this.name, 'Can not send message. Error when parsing string to json.')
          log.warn(this.name, input[1])
        }
        break
      case "settings":
        log.info(this.name, this.settings)
        break
      case "reconnect":
        this.reconnect(this.settings)
        break
      default:
        log.warn(this.name, 'no such command: ' + input[0])
        break
    }
  }
}

/**
* UDP network interface
* send and receive UDP messages
*
* based on dgram module
* best understood with help of:
* {@link https://www.hacksparrow.com/node-js-udp-server-and-client-example.html}
*
* @param {string} config.name - name identifier for this device
* @param {number} config.settings.port - port to communicate with device. Device and framework port are identical if framework_port is not provided.
* @param {number} [config.settings.framework_port] - distinct port to listen for messages from this UDP device
* @param {string} config.settings.ip - ip of device. Where to send messages to from plai framework
*/
class UDPdevice extends Device {
  constructor(config, db) {
    super(config, db)

    this.reconnect(config.settings)
  }

  /**
  * start udp server to listen for messages
  * if framework_port is not defined, device object listens on port for incomming messages from device
  *
  * @param {Object} settings - new setting properties. See class doc for setting properties.
  */
  reconnect(settings) {
    this.settings = settings

    if (!settings.hasOwnProperty('framework_port')) {
      this.settings['framework_port'] = this.settings.port
    }

    if (this.hasOwnProperty('server')) {
      this.server.close(this.startServer.bind(this))
    } else {
      this.startServer()
    }

  }

  startServer() {
    this.server = dgram.createSocket('udp4')

    this.server.on('listening', function () {
      var address = this.server.address()
      log.debug(this.name, 'listening on ' + address.address + ':' + address.port)
    }.bind(this))

    this.server.on('message', function (message, remote) {

      this.handle(message, remote)
    }.bind(this))

    this.server.on('error', function (err) {
      if (err.code == 'EADDRINUSE') {
        log.error(this.name, 'framework port already in use')
        log.error(this.name, err.message)
      } else {
        log.error(err)
      }
    }.bind(this))

    this.server.bind(this.settings.framework_port, '0.0.0.0')
  }

  handle(message, remote) {
    log.debug(this.name, remote.address + ':' + remote.port + ' - ' + message)
    this.update(message.toString())
    //log.debug(this.name, remote.address + ':' + remote.port +' - ' + message)
  }

  send(msg) {
    if (this.settings.hasOwnProperty('ip')) {
      let json_msg = msg
      if (!Buffer.isBuffer(msg)) {
        msg = new Buffer(JSON.stringify(msg))
      }

      var client = dgram.createSocket('udp4')

      client.send(msg, 0, msg.length, this.settings.port, this.settings.ip, function (err, bytes) {
        if (err) {
          log.error(this.name, err)
        }
        log.debug(this.name, 'send ' + JSON.stringify(json_msg) + ' to ' + this.settings.ip + ':' + this.settings.port)
        client.close()
      }.bind(this))
    } else {
      log.error(this.name, 'try to send message but no ip was defined.')
    }
  }

  close() {
    if (this.hasOwnProperty('server')) {
      this.server.close()
    }
  }
}

/**
* OSC/UDP network interface
* send and receive OSC messages over UDP connection
*
* based on osc-min package
* {@link https://www.npmjs.com/package/osc-min}
*
* @param {string} config.name - name identifier for this device
* @param {number} config.settings.port - port to communicate with device. Device and framework port are identical if framework_port is not provided.
* @param {number} [config.settings.framework_port] - distinct port to listen for messages from this UDP device
* @param {string} config.settings.ip - ip of device. Where to send messages to from plai framework
* @param {string} config.settings.path - device OSC path that is prepended to message OSC path
*/
class OSCdevice extends UDPdevice {
  constructor(config, db) {
    super(config, db)
  }

  /**
  * send OSC formatted message. For every (nested) property a seperate message is send.
  */
  send(msg) {
    const osc_msg = [...this.toOSC(msg)]

    for (let o of osc_msg) {
      if (o.hasOwnProperty('addr') &amp;&amp; o.hasOwnProperty('args')) {
        if (this.settings.hasOwnProperty("path")) {
          o.addr = this.settings.path + o.addr
        }
        log.info(this.name, o)
        let buf = osc.toBuffer({
          address: o.addr,
          args: o.args
        })

        super.send(buf)
      }
    }
  }

  /**
  * itereate through object and convert it to osc compatible message
  * e.g.: {one:{two:{three:4}}} becomes {address:"/one/two/three", args 4}
  * 
  * created with help of Jonas Wilms:
  * https://stackoverflow.com/questions/54634869/convert-json-to-osc-address-and-arguments/54635002#54635002
  */
  * toOSC(obj, previous = "") {
    for (const [key, value] of Object.entries(obj)) {
      if (typeof value !== "object" || Array.isArray(value)) {
        yield { addr: previous + "/" + key, args: value };
      } else {
        yield* this.toOSC(value, previous + "/" + key);
      }
    }
  }

  route(osc_msg) {
    let osc_data = {}
    let path = osc_msg.address.replace(/\//g, '.')
    path = path.slice(1)
    if (osc_msg.args.length > 1) {
      let values = []
      for (let arg of osc_msg.args) {
        values.push(arg.value)
      }
      osc_data[path] = values
    } else {
      let value = osc_msg.args[0].value
      osc_data[path] = value
    }

    return osc_data
  }

  /**
  * cast incomming OSC messages to a json format and update Database with incomming
  * function is called by UDP event handler and overwrites UDPDevice.handle() function
  */
  handle(message, remote) {
    if (Buffer.isBuffer(message)) {
      try {
        message = osc.fromBuffer(message)
        let data = this.route(message)
        //log.debug(this.name, "routed incomming OSC msg: ")
        //log.debug(this.name, data)
        this.update(data)
      } catch (error) {
        log.warn(this.name, "invalid OSC packet")
        log.warn(this.name, error)
        return
      }
    } else {
      log.warn(this.name, "Incomming msg is not a Buffer. Type: " + typeof (message))
    }
  }
}



/**
* TCP network interface
* send and receive TCP messages
*
* based on net module
* best understood with help of:
* {@link https://www.hacksparrow.com/tcp-socket-programming-in-node-js.html}
*
* @param {string} config.name - name identifier for this device
* @param {number} config.settings.port - port to communicate with device. Device and framework port are identical if framework_port is not provided.
* @param {number} [config.settings.framework_port] - distinct port to listen for messages from this UDP device
* @param {string} config.settings.ip - ip of device. Where to send messages to from plai framework
*/
class TCPdevice extends Device {
  constructor(config, db) {
    super(config, db)

    this.reconnect(config.settings)
  }

  /**
  * start tcp server to listen for messages
  * if framework_port is not defined, device object listens on port for incomming messages from device
  *
  * @param {Object} settings - new setting properties. See class doc for setting properties.
  */
  reconnect(settings) {
    this.settings = settings

    if (!settings.hasOwnProperty('framework_port')) {
      this.settings['framework_port'] = this.settings.port
    }

    if (this.hasOwnProperty('server')) {
      if (this.server.listening) {
        this.server.close(this.startServer.bind(this))
      } else {
        log.warn(this.name, "tcp server was not running properly. Try to Reconnect none the less.")
        this.startServer()
      }
    } else {
      this.startServer()
    }

  }

  startServer() {
    this.server = net.createServer()

    this.server.listen({ port: this.settings.framework_port, host: '0.0.0.0' }, function () {
      log.debug(this.name, 'listening on ' + this.server.address().address + ':' + this.server.address().port)
    }.bind(this))

    this.server.on('error', function (err) {
      switch (err.code) {
        case 'EADDRINUSE':
          log.error(this.name, 'Port ' + err.port + ' already in use!')
          break

        default:
          log.error(this.name, err)
      }
    })

    this.server.on('connection', function (sock) {
      log.debug(this.name, 'connected ' + sock.remoteAddress + ':' + sock.remotePort)

      sock.on('data', function (data) {
        //log.debug(this.name, 'incomming ' + sock.remoteAddress + ': ' + data)
        this.handle(data.toString(), sock)
        // this.update(data.toString())
        // Write the data back to the socket, the client will receive it as data from the server
        // sock.write('Response "' + data + '"');
      }.bind(this))

      sock.on('close', function (data) {
        log.debug(this.name, 'closed ' + sock.remoteAddress + ':' + sock.remotePort);
      }.bind(this))
    }.bind(this))
  }

  /**
  * default handle function. Overwrite if you want to deal with incomming messages from child class
  * 
  */
  handle(message, socket) {
    log.debug(this.name, 'incomming ' + socket.remoteAddress + ': ' + message)
    this.update(message)
  }

  send(msg) {
    if (this.settings.hasOwnProperty('ip')) {
      var client = new net.Socket()

      client.connect(this.settings.port, this.settings.ip, function () {
        log.debug(this.name + ' send', msg)
        client.write(JSON.stringify(msg))
        client.destroy()
      }.bind(this))

      client.on('data', function (data) {
        log.debug(this.name + ' sent', data)
        client.destroy()
      }.bind(this))

      client.on('close', function () {
        log.debug(this.name, 'closed')
      }.bind(this))

      client.on('error', function (err) {
        log.error(this.name, 'couldn`t send tcp message to ' + err.address + ':' + err.port + ': ')
        log.error(this.name, msg)
        switch (err.code) {
          case 'ECONNREFUSED':
            log.error(this.name, 'Connection was REFUSED')
            break

          case 'EHOSTUNREACH':
            log.error(this.name, 'unable to REACH HOST')
            break

          case 'EHOSTDOWN':
            log.error(this.name, 'HOST is DOWN')
            break

          case 'ETIMEDOUT':
            log.error(this.name, 'connection TIMED OUT')
            break

          default:
            log.error(this.name, err)
        }
      }.bind(this))
    } else {
      log.error(this.name, 'try to send message but no ip was defined.')
    }
  }

  close() {
    if (this.hasOwnProperty('server')) {
      if (this.server.listening) {
        this.server.close()
      }
    }
  }
}

/**
* http request interface.
* Handles requests to the device and allows to make remote requests
*
* @param {string} config.name - name identifier for this device
* @param {string} config.settings.url - url or ip of device with port and path
* @param {string} config.settings.host - url or ip of device
* @param {string} config.settings.path - path to device on host
* @param {string} [config.settings.route=config.name] - route path for requests from device
* @param {string} [config.settings.method] - POST or GET (default)
* @param {number} [config.settings.port] - path to device on host if not 8080
* @param {Object} express_app - access to express app object
*/
class Webdevice extends Device {
  constructor(config, db, express_app) {
    super(config, db)
    this.app = express_app
    this.json = true

    this.settings = this.buildDefaults(this.settings)

    if (config.settings.hasOwnProperty('method')) {
      if (config.settings.method.toUpperCase() == 'POST') {
        this.app.post(config.settings.route, this.handle.bind(this))
      } else {
        this.app.get(config.settings.route, this.handle.bind(this))
      }
    } else {
      this.app.get(config.settings.route, this.handle.bind(this))
    }
    
    this.storeSettings()
    
    log.debug(this.name, "connected:")
    log.debug(this.name, config.settings)
  }

  /**
  * if no routing is specified, create routing from name.
  * make sure that spaces in name are replaced if any
  *
  * if no url or uri specified, create form host and port.
  *
  * @param {Object} settings - current settings
  *
  * @returns {Object} settings with adapted defaults.
  */
  buildDefaults(settings) {
    if (!settings.hasOwnProperty('route')) {
      let name_convert_spaces = this.name.replace(/ /g, '%20')
      settings.route = '/' + name_convert_spaces
    }
    //if (!settings.hasOwnProperty("url") &amp;&amp; !settings.hasOwnProperty("uri")) {
      if (settings.hasOwnProperty('host') &amp;&amp; settings.hasOwnProperty('port')) {
        if (settings.hasOwnProperty('path')) {
          settings.url = 'http://' + settings.host + ':' + settings.port + '/' + settings.path
        } else {
          settings.url = 'http://' + settings.host + ':' + settings.port
        }
      } else if (!settings.hasOwnProperty("url") &amp;&amp; !settings.hasOwnProperty("uri")) {
        log.error(this.name, 'Can not create webdevice url. Host and/or Port property missing')
      }
      //this.settings.uri = 'http://' + settings.host + ':' + settings.port + '/' + settings.path
    //}
    
    return (settings)
  }

	/**
	* reconnect http device
	* set outgoing request properties
	* open routing on new route path
	* close previous route path. With help from:
	* https://stackoverflow.com/questions/10378690/remove-route-mappings-in-nodejs-express/28369539#28369539
	*
  * @param {Object} settings - new setting properties. See class doc for setting properties.
  */
  reconnect(settings) {
    settings = this.buildDefaults(settings)
    if (settings.route != this.settings.route) {
      this.removeRoute(this.settings.route)
      if (settings.hasOwnProperty('method')) {
        if (settings.method.toUpperCase() == 'POST') {
          this.app.post(settings.route, this.handle.bind(this))
        } else {
          this.app.get(settings.route, this.handle.bind(this))
        }
      } else {
        this.app.get(settings.route, this.handle.bind(this))
      }
    }

    this.settings = settings
    
    this.storeSettings()
    
    log.debug(this.name, "reconnected:")
    log.debug(this.name, this.settings)
  }

  removeRoute(path) {
    log.debug(this.name, "remove route: " + path)
    this.app._router.stack.forEach(function (routing, i, routes) {
      if (routing.route) {
        if (routing.route.hasOwnProperty('path')) {
          //log.debug(0, "check " + routing.route.path)
          if (routing.route.path == path) {
            routes.splice(i, 1)
            log.info(0, 'express route removed: ' + routing.route.path)
          }
        }
      }
    })
  }

	/**
	* send json to device
	*/
  send(data) {
    this.request(data)
  }

  /**
  * deal with requests to this http device
  */
  handle(req, res) {
    try {
      if (!medley.isEmpty(req.body)) {
        log.info(this.name, req.body)
        this.update(req.body)
      } else if (!medley.isEmpty(req.query)) {
        if (req.query.hasOwnProperty("data")) {
          log.info(this.name, req.query.data)
          this.update(req.query.data)
        } else {
          log.info(this.name, req.query)
          this.update(req.query)
        }
      } else {
        log.warn(this.name, "Request with no body or query data. Headers:")
        log.warn(this.name, req.headers)
        log.warn(this.name, req.query)
        log.warn(this.name, req.body)
        //log.warn(this.name, req)
      }
      res.status(200)
      res.send("OK")
    } catch (e) {
      log.error(this.name, new Error(e))
    }
  }

	/**
	* make request to device
	*/
  request(data) {
    return new Promise((resolve, reject) => {
      if (typeof message === 'string') {

      } else {
        data = JSON.stringify(data)
      }
      log.info(this.name, "request: ")
      log.info(this.name, data)
      try {
        this.settings.body = data + "\n"
        this.settings.query = "data=" + data
        this.settings.headers = { "content-type": "application/json" }
        let req = request(this.settings, (err, response, body) => {
          if (err) { log.error(this.name, new Error(err)); return reject(err); }
          if (response.hasOwnProperty('statusCode')) {
            if (response.statusCode == 404) {
              log.error(this.name, "Status 404")
              return reject("Request returned with status 404")
            } else {
              log.info(this.name, "response status:", response.statusCode)
              return resolve()
            }
          } else {
            log.warn(this.name, "invalid response (status code missing)")
            return resolve()
          }
        })
      } catch (err) {
        log.error(this.name, err)
      }
    })
    
  }

	/**
	* handle response from request
	*/
  request_callback(err, response, body) {
    if (err) { log.error(this.name, new Error(err)); return; }
    if (response.hasOwnProperty('statusCode')) {
      if (response.statusCode == 404) {
        log.error(this.name, "Status 404")
      } else {
        log.info(this.name, "response status:", response.statusCode)
      }
    } else {
      log.warn(this.name, "invalid response (status code missing)")
    }
  }

	/**
	* stop routing
	*/
  close() {
    this.removeRoute(this.settings.route)
  }
}

/**
* serial interface
* serialport module API:
* https://serialport.io/docs/api-stream
*
* @param {Object} config - configuration properties for this serial device
* @param {Object} config.settings - Serial connection properties
* @param {Object} config.settings.port - serial port
* @param {Object} [config.settings.baud=115200] - Serial connection baud rate
*/
class Serialdevice extends Device {
  constructor(config, db) {
    if (SerialPort) {
      super(config, db)
      this.reconnect(config.settings)
    } else {
      super(config, db)
      log.error(0, "Can't create Serial Device. serialport module not installed.")
    }
  }

  /**
  * close (if open) and open Serial connection.
  * @param {Object} settings - new setting properties. See class doc for setting properties.
  *
  */
  reconnect(settings) {
    if (this.hasOwnProperty('conn')) {
      if (this.conn.isOpen) {
        this.conn.close()
      }
    }

    if (!settings.hasOwnProperty('baud')) {
      settings.baud = 115200
    }

    this.settings = settings

    this.conn = new SerialPort(settings.port, { baudRate: settings.baud }, function (err) {
      if (err) {
        log.error(this.name, 'tried connecting ' + settings.port)
        log.error(this.name, err.message)

        this.conn.on('open', function () {
          log.info(this.name, 'port is now open')
        }.bind(this))
      } else {
        this.connected()
      }
    }.bind(this))
  }

  connected() {
    const parser = this.conn.pipe(new Readline({ delimiter: '\r\n' }))
    parser.on('data', function (message) {
      log.debug(this.name, message.toString());
      this.update(message)
    }.bind(this));
  }

  send(msg) {
    let message = JSON.stringify(msg)
    this.conn.write(message + "\n", function (err) {
      if (err) {
        log.error(this.name, 'tried to send ' + message)
        log.error(this.name, err.message)
      } else {
        log.debug(this.name + ' send', message)
      }
    }.bind(this))
  }

  close() {
    if (this.hasOwnProperty('conn')) {
      if (this.conn.isOpen) {
        this.conn.close()
      }
    }
  }
}

/**
* midi interface
* uses:
* https://www.npmjs.com/package/midi
*
*/
class Mididevice extends Device {
  constructor(config, db) {
    if (midi) {
      super(config, db)
      this.reconnect(config.settings)
    } else {
      log.error(0, "Can't create Midi Device. node-midi module not installed.")
    }
  }

  /**
  * close (if open) and open Midi input and output
  * route incomming midi by channel except its 0 (any)
  * create virtual Port if input or output port is the vitual port name dafined by game
  *
  * @param {Object} settings - new setting properties. See class doc for setting properties.
  *
  */
  reconnect(settings) {
    if (this.hasOwnProperty('input')) {
      this.input.closePort()
    }

    this.settings = settings

    this.input = new midi.input()

    this.input.on('message', function (deltaTime, message) {
      let status = {}
      if (message[0] &lt; 144) {
        status.channel = message[0] - 127
        log.debug(this.name, 'note off ' + message + ' time: ' + deltaTime)
      } else if (message[0] &lt; 160) {
        status.channel = message[0] - 143
        log.debug(this.name, 'note on ' + message + ' time: ' + deltaTime)
      } else {
        log.warn(this.name, 'unknown midi status: ' + message[0])
        return
      }

      status.pitch = message[1]
      status.velocity = message[2]
      status.note = message[1] + ' ' + message[2]

      if (this.settings.channel == status.channel || this.settings.channel == 0) {
        this.update(status)
      }
    }.bind(this))

    // Connect Input
    let connected = false

    if (this.settings.input_port == virtual_midi_port) {
      this.input.openVirtualPort(this.settings.input_port)
      log.info(this.name, 'connected midi input on virtual port: ' + this.settings.input_port)
      connected = true
    } else {
      for (let i = 0; i &lt; this.input.getPortCount(); i++) {
        if (this.settings.input_port == this.input.getPortName(i)) {
          this.input.openPort(i)
          log.info(this.name, 'connected midi input on port: ' + this.input.getPortName(i))
          connected = true
        }
      }
    }


    if (!connected) {
      log.info(this.name, 'could not connect. no such midi input port: ' + this.settings.input_port)
    }

    // Connect Output
    if (this.hasOwnProperty('output')) {
      this.output.closePort()
    }

    this.output = new midi.output()

    connected = false
    if (this.settings.output_port == virtual_midi_port) {
      this.output.openVirtualPort(this.settings.output_port)
      log.info(this.name, 'connected midi output on virtual port: ' + this.settings.output_port)
      connected = true
    } else {
      for (let i = 0; i &lt; this.output.getPortCount(); i++) {
        if (this.settings.output_port == this.output.getPortName(i)) {
          this.output.openPort(i)
          log.info(this.name, 'connected midi output on port: ' + this.output.getPortName(i))
          connected = true
        }
      }
    }


    if (!connected) {
      log.info(this.name, 'could not connect. no such midi output port: ' + this.settings.output_port)
    }
  }

  /**
  * send note on midi message based on either:
  * a blank (' ') seperated string with two numbers (pitch and velocity)
  * a number for each pitch and velocity
  */
  send(msg) {
    let channel = this.settings.channel + 143
    if (msg.hasOwnProperty("channel")) {
      channel = msg.channel + 143
    }

    let snd = [channel, 0, 0]

    if (msg.hasOwnProperty("note")) {
      msg = msg.note.split(" ")
      snd[1] = msg[0]

      if (msg.length == 2) {
        snd[2] = msg[1]
      }
    }
    if (msg.hasOwnProperty("pitch")) {
      snd[1] = msg.pitch
    }
    if (msg.hasOwnProperty("velocity")) {
      snd[2] = msg.velocity
    }

    this.output.sendMessage(snd)
    log.debug(this.name, 'send', snd[0], snd[1], snd[2])
  }

  close() {
    if (this.hasOwnProperty('output')) {
      this.output.closePort()
    }
    if (this.hasOwnProperty('input')) {
      this.input.closePort()
    }
  }
}

module.exports = {
  getDevice: getDevice,
  midi: midi,
  activateMidi:activateMidi,
  deactivateMidi:deactivateMidi,
  getPorts: getPorts,
  Device: Device,
  UDPdevice: UDPdevice,
  OSCdevice: OSCdevice,
  osc: osc,
  TCPdevice: TCPdevice,
  Webdevice: Webdevice,
  Serialdevice: Serialdevice,
  Mididevice: Mididevice,
  setVirtualMidiPort: setVirtualMidiPort
}
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-plugin-Collection.html">Collection</a></li><li><a href="module-plugin-Item.html">Item</a></li><li><a href="module-plugin-Plugin.html">Plugin</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Tue Dec 17 2019 17:26:50 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
